unit RegAffich;                                     {05/03/2012}
             //  Gestion des donnes : modification, ajout ou suppression
interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, StdCtrls, FileCtrl;

type
  TTrait = (AjoutLg, ModifLg, SuppLg, Affich, SupFich, ModTitre); // liste fonct.
  TTypTT = (TTPoly, TTMult);                         // liste types regressions

  TFRegAff = class(TForm)
    FlbAff: TFileListBox;
    StbAff: TStatusBar;
    Label1: TLabel;
    LiBAff: TListBox;
    EdTrait: TEdit;
    BtTrait: TButton;
    MemAff: TMemo;
    BtEnregModif: TButton;
    EdNomF: TEdit;
    BtImp: TButton;
    Label2: TLabel;
    procedure FlbAffClick(Sender: TObject);  // initiation fonction
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure LiBAffClick(Sender: TObject); // affich zone selectionne
    procedure BtTraitClick(Sender: TObject); // traitement des fonctions ligne
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure BtEnregModifClick(Sender: TObject); // enregistrement modif
    procedure FormActivate(Sender: TObject);
    procedure BtImpClick(Sender: TObject);   //impression
  private
    { Dclarations prives }
    NficAff : string;           // fichier affichage   .pya  ou .mua
    NficDon : string;           // nom du fichier donnes .pyd ou .mud
    NFicResult : string;        //                rsultats  .pyr ou .mur
    IxAff : integer;            // index ligne affiche
    Titred : string;
    NVar, NSeries : integer;
    Xmod : array of Double;     // donnes modifies
    TitFiche : string;   // titre  de la fiche
    procedure P_EnregistrerMod; // si OK enregistrer les donnes sous un nouveau nom
       // si le nom est conserv le fichier rsultats est effac (.pyr ou .mur)
  public
    { Dclarations publiques }
    ModeTT : TTrait ;          // types de modification
    TypeTT : TTypTT;           // types de traitement polynom ou multyple
    StlAffich : TstringList;       // liste fic. affichage
    StlDonModif : TStringList;       // liste des donnes brutes modifies
  end;

var
  FRegAff: TFRegAff;

implementation

uses RegresPoly, RegresMultip, RegMenu, ListImp;

{$R *.dfm}

const CrLg = #13#10;

procedure TFRegAff.BtEnregModifClick(Sender: TObject);  // enregistrement modif
begin
  if ModeTT = ModTitre  then Exit;
  P_EnregistrerMod;
  BtEnregModif.Visible := False
end;

procedure TFRegAff.BtImpClick(Sender: TObject);
var Ch : string;
begin
  if TypeTT = TTPoly then Ch := '    Regression Polynomiale'
                    else Ch := '    Regression Multiple';
  try
    FImprime := TFImprime.Create(Self);
    FImprime.ImpSTList(ExtractFileName(NficAff),Ch, NficAff, StlAffich);
    Caption := TitFiche;
  finally
    FImprime.Free;
  end;
end;

//===========================================================================
procedure TFRegAff.BtTraitClick(Sender: TObject);  // traitements des fonctions
var                                                // ligne
  NumLg, IxD : integer;
  NbDonLig :  integer;      // nombre de donnes par ligne
  Xi, Xm, Yi : Tdon;       // X initial et modifi
  I : integer;
  Ix : integer;          // index de la donne dans StlDonM
  LgAff : string;        // ligne affichage
  TitreMod : string;     // titre modifi

function AnalyseLg(Ch : string): boolean;  // lecture du contenu de ch (nombres)
var
  I, J, Code : integer;
  Chnbr : string;
  Nb : double;
begin
  Result :=  true;
  Ch := Trim(Ch);    // Ch contient une liste de valeurs spars par des espaces
  J := 0;            // indice initial de Xmod
  repeat
    Ch := Ch+' ';                            // espace = fin de donne
    for I := 1 to Length(Ch) do
      if Ch[I] = ' ' then
      begin
        Chnbr := Copy(Ch, 1, I-1);
        Val(Chnbr, Nb, Code);
        if Code <> 0 then
        begin
          MessageDlg('La ligne selectionne n''est pas une DONNEES', mtWarning,
                       [mbOK], 0);
          Result := False;
          Exit;
        end;
        Xmod[J] := StrToFloat(Chnbr);  // extraction d'une valeur
        Inc(J);
        Ch := Copy(Ch,I+1,Length(Ch));
        Break ;
      end;
      Ch := Trim(Ch);
  until Ch='';

  if J < NbDonLig then    // verif nb donnes dans la ligne
    begin
      ShowMessage('Il manque une/des valeurs');
      EdTrait.SetFocus;
      Result := false;
      Exit;
    end;

  if TypeTT = TTPoly then      //regres. poly affectation des var. X et Y
    begin
      Xi := Xmod[1];    // dans le tableau des valeurs modifies - X
      Yi := Xmod[2];    //                                         Y
    end;                      // reg. multiple tableau Xmod
end;

procedure Maj_NumSer(Ix : integer);   //  maj num series
var                                  // sup. ligne diminution du n srie
  Lg, ChN : string;
  N : integer;                      // N limit  999 sries de donnes ?
begin
  Lg := StlAffich[Ix];
  ChN := Copy(Lg, 1, 3);
  N := StrToInt(ChN);
  Dec(N);
  ChN := IntToStr(N);
  while Length(ChN) < 3  do  ChN := ' ' + ChN;
  Lg := ChN + Copy(Lg, 4, Length(Lg));
  StlAffich[Ix] := Lg;
end;

procedure P_LgAff(var Lg : string; Const Nb : integer; Xtab : array of Double);
var I, N : integer;      // formatage de la ligne Lg
begin
  N := Trunc(Xmod[0]);
  Lg := Format('%3d',[N]);
  for I := 1 to Nb-1  do
  Lg := Lg + StringOfChar(' ',18-Length(FloatToStr(Xtab[I])))+ FloatToStr(Xtab[I]);
end;

procedure P_SupFichiers;  // on peut supprimer soit le fichier rsultats
var NomFic : string;      // ou tous les fichiers d'une rgression
begin
  StbAff.SimpleText := ' Suppression du fichier rsultats OU tous les fichiers';
  NomFic := ExtractFileName(NFicResult);   // fichier rsultat ou affichage
  NomFic := Copy(NomFic, 1, Length(NomFic)-4);  // nom du fichier sans extension
  if FileExists(NFicResult) then
    if MessageDlg('Voulez-vous SUPPRIMER le fichier RESULTATS' + CrLg
      + NFicResult, mtConfirmation,[mbYes, mbNo], 0) = mrYes  then
      begin
        DeleteFile(NFicResult);
        DeleteFile(NomFic+'.coef');
        Exit;
      end;

  if MessageDlg('Voulez-vous SUPPRIMER TOUS les fichiers relatif ' + CrLg
    +' "'+ NomFic + '"', mtConfirmation,[mbYes, mbNo], 0) = mrYes  then
  begin
    DeleteFile(NficAff);
    DeleteFile(NficDon);
    if FileExists(NFicResult) then DeleteFile(NficResult);
    if FileExists(NomFic+'.coef') then DeleteFile(NomFic+'.coef');
  end;
   StbAff.SimpleText := '';
end;

procedure P_CalNouvDonPoly;
           // calcul des nouvelles donnes apres ajout/suppression d'une srie
var Lg : string;           // on reconstruit totalement les donnes brutes
    I, J : integer;
    Nb, Code : integer;
begin
  StlDonModif.Clear;
    I := 0;
    repeat               // lecture de l'en tte
      Inc(I);
      Lg := StlAffich[I];
      Lg := Copy(Lg, 1, 3);     // un espace + 2 chiffres
      Val(Lg, Nb, Code);
    until (Code = 0) and (Nb = 1);

    repeat
      Lg := StlAffich[I];
      inc(I);
      if AnalyseLg(Lg) then       // on saute les 4 premires lignes
      begin
        Xm := Xi;
        StlDonModif.Add(FloatToStr(Xi));
        for J := 2 to (Nvar-1) do
        begin
          Xm := Xm * Xi;        // calcul des puissances de X
          StlDonModif.Add(FloatToStr(Xm)); // sauvegarde
        end;
        StlDonModif.Add(FloatToStr(Yi));
      end;
  until   I > StlAffich.Count - 1;   //[0] = NSeries;
  StlDonModif.Add(IntToStr(Nseries));
  StlDonModif.Add(IntToStr(NVar));
  StlDonModif.Add(Titred);
end;

//-------------------------- BtTraitClick-------------------------------------
begin
  if  ModeTT = SupFich then
    begin
      P_SupFichiers;
      LiBAff.Clear;
      EdTrait.Text := '  ';
      BtTrait.Visible := False;
      FlbAff.Update;
      Exit;
    end;

  if ModeTT = ModTitre  then  // modification titre et enregistrement 
  begin
    if MessageDlg('Modifier le Titre : '+CrLg+ EdTRait.Text,
                      mtConfirmation, [mbYes,mbNo], 0) = mrYes then
      begin
        TitreMod := EdTrait.Text;        // titre modifi
        LiBAff.Items[0] := TitreMod;     // affichage dans boite liste
        Show;
        if MessageDlg('Enregistrer le nouveau TITRE : '+ CrLg + TitreMod,
                  mtConfirmation, [mbYes,mbNo], 0) = mrYes then
        begin
          StlAffich[0] := TitreMod;   // mj stringlist Affichage
          StlAffich.SaveToFile(NficAff);  // sauvegarde des stringlist : Aff
          StlDonModif[IxAff] := TitreMod;    // mj stringlist Don
          StlDonModif.SaveToFile(Copy(NFicAff, 1, Length(NFicAff)-1)+'d');
          StlDonModif.LoadFromFile(Copy(NFicAff, 1, Length(NFicAff)-1)+'r'); //chargement
          StlDonModif[0] := TitreMod;       // mj str list Resultat
          StlDonModif.SaveToFile(Copy(NFicAff, 1, Length(NFicAff)-1)+'r'); // sauveg.
          StbAff.SimpleText := '   Mise  jour Modif. Titre faite';
          BtEnregModif.Visible := False;
        end;
      end    ;
    exit;
  end;

  if TypeTT = TTPoly then  NbDonLig := 3           // n serie, X et Y
                     else  NbDonLig := Nvar + 1;   // donnes + n serie
  SetLength( Xmod, NbDonLig);              // dimension de Xmod
  For I := 0 to Nvar-1 do Xmod[I] := 0;    // initialisation

  if not AnalyseLg(EdTrait.Text)       // Lecture du contenu de la ligne modif.
                    then Exit;         // erreur dans le contenu de la ligne
  NumLg := Trunc(Xmod[0]);         // numro de ligne
  Ixd := (NumLg-1)* Nvar;          // index de la  position d'enregistrement

  case ModeTT of

  ModifLg : begin // modif. d'une ligne (traitement modif reg. polynomiale P_TTpoly)
            Xm := Xi;
            if MessageDlg('Enregistrer la serie : '+CrLg+ EdTrait.Text,
                      mtConfirmation, [mbYes,mbNo], 0) = mrYes then
            begin
              if TypeTT = TTPoly then
                begin
                  StlDonModif[Ixd] := FloatToStr(Xi);
                  Inc(Ixd);
                  for I := 2 to (Nvar-1) do
                    begin
                      Xm := Xm * Xi;                // calcul des puissances de X
                      StlDonModif[Ixd] := FloatToStr(Xm); // sauvegarde
                      Inc(Ixd);
                    end;
                  Ixd := NumLg * Nvar - 1;
                  StlDonModif[Ixd] := FloatToStr(Yi);
                  StlAffich[IxAff] := EdTrait.Text;
                  LiBAff.Items := StlAffich;
                end;

              if TypeTT = TTMult then
                begin
                   Ix := Ixd;
                   for I := 1 to NbDonLig-1 do
                   begin
                     StlDonModif[Ix] := FloatToStr(Xmod[I]);
                     Inc(Ix);
                   end;
                   LgAff := '';
                   P_LgAff(LgAff, NbDonLig, Xmod);
                   StlAffich[IxAff] := LGAff;
                   LiBAff.Items := StlAffich;
                end;
            end     // fin Then message Enregistrer

            else begin        // enregistrer = NON   modif.
                  EdTrait.SetFocus;
                  Exit;
                 end;
          end;
      //   modif  -----------------------------------------------------------
  AjoutLg : Begin        // ajout d'une ligne de donnes
              P_LgAff(LgAff, NbDonLig, Xmod);
              if Dialogs.MessageDlg('Enregistrer les donnes : '+ CrLg + LgAff,
                  mtConfirmation, [mbYes,mbNo], 0) = mrYes then
              begin
                if TypeTT = TTPoly then
                begin
                  Inc(NSeries);
                  LiBAff.Items.Add(LgAff);       // mj affichage listbox
                  StlAffich.Add(LgAff);          // mj liste chanes affichage
                  if MessageDlg('Ajouter d''autres donnes  ?', mtConfirmation,
                     [mbYes, mbNo], 0) = mrYes then
                     begin                         // on continue Ajout
                       StBAff.SimpleText :=
                  '  Pour AJOUTER une nouvelle srie donner les 3 valeurs et OK';
                       Inc(NumLg);
                       EdTrait.Text := ' '+IntToStr(NumLg);
                       EdTrait.SetFocus;
                       Exit;
                     end
                     else begin                            //ajout termin
                            P_CalNouvDonPoly;   // calcul des nouvelles donnes
                            StBAff.SimpleText := ' Enregistrer les modifications';
                         end;
                end;

                if TypeTT = TTMult then            //  Ajout ligne modif 17/02/2011
                begin
                  I := StlDonModif.Count - 1;
                  StlDonModif.Delete(I);       // suppression du titre
                  StlDonModif.Delete(I - 1);  //             nb variables
                  StlDonModif.Delete(I - 2);  //             nb series
                  for I := 1 to NbDonLig-1 do
                  begin
                   StlDonModif.Add(FloatToStr(Xmod[I]));
                   Inc(Ix);
                  end;
                  Inc(NSeries);                         // mj nb series
                  StlDonModif.Add(IntToStr(NSeries));  // enregistrement suppressions
                  StlDonModif.Add(IntToStr(NVar));
                  StlDonModif.Add(Titred);
                  LgAff := '';
                  P_LgAff(LgAff, NbDonLig, Xmod);
                  StlAffich.Add(LGAff);
                  LiBAff.Items := StlAffich;
                end
              end
              else begin          // on n'enregistre pas l'ajout d'une srie
                     EdTrait.SetFocus;
                     Exit;
                   end;
          end;         // Ajout

    SuppLg : begin                                // suppression d'une ligne
              if MessageDlg('Supprimer les donnes : '+CrLg+ EdTrait.Text,
                  mtConfirmation, [mbYes,mbNo], 0) = mrYes then
              begin
                if TypeTT = TTPoly then
                 begin
                  StlAffich.Delete(IxAff);
                  Dec(NSeries);

                  while IxAff <= (StlAffich.Count - 1) do  // renumrotation des lignes
                     begin
                       Maj_NumSer(IxAff);                 // mj num series
                       Inc(IxAff);
                     end;
                  LiBAff.Items := StlAffich;
                  if MessageDlg('Supprimer d''autres donnes ?', mtConfirmation,
                     [mbYes, mbNo], 0) = mrYes then
                     begin                         // on continue Suppression
                       StBAff.SimpleText := '  Supprimer une nouvelle srie ';
                       EdTrait.SetFocus;
                       Exit;
                     end
                     else begin                      // suppression termine
                            P_CalNouvDonPoly;   // calcul des nouvelles donnes
                            StBAff.SimpleText := ' Enregistrer les modifications';
                         end;
                 end;

                if TypeTT = TTMult then
                 begin
                    for I := 1 to Nvar do
                           StlDonModif.Delete(IxD);  // suppression de la ligne
                    Dec(NSeries);                    //  mj nb series
                    StlDonModif[StlDonModif.Count - 3] := IntToStr(NSeries);
                    StlAffich.Delete(IxAff);
                     I := IxAff;
                    while I <= (StlAffich.Count - 1) do  // renumrotation des lignes
                     begin
                       Maj_NumSer(I);                 // mj num series
                       Inc(I);
                     end;
                    LiBAff.Items := StlAffich;
                 end;
              end
              else begin                 // on n'enregistre pas la suppression
                     EdTrait.SetFocus;
                     Exit;
                   end;
                 EdTrait.Text := '';
            end;
  end;
  LiBAff.Items := StlAffich;
  BtEnregModif.Visible := True;
  BtEnregModif.SetFocus;
  Show;
end;
//=============================================================================

procedure TFRegAff.P_EnregistrerMod;
var
  NomDon : string;    // nom du fichier
  NomExt : string;   // extension du fichier rduite
  NomDonN : string;   // nouveau nom du fichier
  BNouvNom : boolean;  //  Inputquery
  Lg : string;
begin
  NomDon :=  ExtractFileName(NficAff);       // fichier .pya  .mua
  NomExt := ExtractFileExt(NFicAff);
  NomDon := Copy(NomDon, 1, Length(NomDon)-4);   // nom du fichier sans extension
  NomDonN := NomDon;
  StbAff.SimpleText := ' Si le NOM est CONSERVE le F.RESULTATS actuel sera SUPPRIME';
  if MessageDlg('Modifier le NOM du FICHIER ?'+CrLg+
                ' : '+ NomDon, mtConfirmation, [mbYes, mbNo], 0) = mrYes then
     begin
       Lg := 'Enregistrer sous un nouveau NOM';
       repeat
         BnouvNom := InputQuery(Lg,'  Donner le nouveau NOM ', NomDonN ); // vrai si nom modif.
         if not BnouvNom then Exit;      // annulation
         
         if FileExists(NomDonN+NomExt) then begin
                                              BnouvNom := False;
                                              Lg := '  Ce NOM existe';
                                            end;
       until BnouvNom;     // rponse OUI mais nom pas chang
     end
     else BNouvNom := False;

  if BNouvNom    then                      // on enregistre sous un nouveau nom
      begin
          NFicResult := NomDonN + NomExt;
          NFicDon := NomDonN + Copy(NomExt, 1, 3) + 'd';
          StlAffich.SaveToFile(NFicResult);
          StlDonModif.SaveToFile(NFicDon);
      end
    else                                   // on enregistre avec l'ancien nom
    begin
      StlAffich.SaveToFile(NficAff);
      StlDonModif.SaveToFile(Copy(NFicAff, 1, Length(NFicAff)-1)+'d');
      DeleteFile(Copy(NFicAff, 1, Length(NFicAff)-1)+'r');
      NFicAff := Copy(NFicAff, 1, Length(NFicAff)-4)+'.coef';
      DeleteFile(NFicAff);   //Copy(NFicAff, 1, Length(NFicAff)-4)+'coef');
    end;
  StbAff.SimpleText :=
     ' Mise  jour faite, faire une nouvelle Mise  Jour ou FERMER';
end;

procedure TFRegAff.FlbAffClick(Sender: TObject);   // initiation fonction
var I : integer;
   NficSel : string;     // nom du fichier slectionn
begin
  NficSel := FlbAff.FileName;          // fichier slection
  Label2.Caption := ExtractFileName(NficSel);
  StlAffich.LoadFromFile(NficSel);     // chargement des donnes affichage
  LiBAff.Items := StlAffich;

  NficDon := Copy(NficSel, 1, Length(NficSel)-1)+'d';  // nom fich. donnes
  NFicAff := Copy(NficSel, 1, Length(NficSel)-1)+'a';   // nom f. affichage
  NFicResult := Copy(NficSel, 1, Length(NficSel)-1)+'r';   // nom f. rsultats

  if ExtractFileExt(NficAff) = '.pya' then TypeTT := TTPoly
                                      else TypeTT := TTMult;

  if ModeTT = Affich then       // affichage
  begin
    NFicAff := NficSel;
    BtTrait.Visible := False;
    Exit
  end;

  if ModeTT = SupFich then    // suppression de fichier(s)
  begin
    EdTrait.Text := NFicSel;
    BtTrait.Visible := True;
    Exit;
  end;

  StlDonModif.LoadFromFile(NFicDon);    // lecture donnes brutes pour calcul
  I := StlDonModif.Count;
  Titred := StlDonModif[I-1];
  Nvar :=  StrToInt(StlDonModif[I-2]);
  NSeries := StrToInt(StlDonModif[I-3]);
  EdNomF.Text := ExtractFileName(NFicAff);

  if ModeTT = ModTitre then             // modif. titre
  begin
    StbAff.SimpleText := '  Modifier le titre';
    EdTrait.Text := Titred;
    EdTrait.SetFocus;
    IxAff := I-1;
    BtTrait.Visible := True;
  end;
  
  if ModeTT = ModifLg then      // modification d'une ligne
  begin
    StbAff.SimpleText :=
       'Slectionner une ligne de DONNEES puis modifier X et/ou Y, puis ENRG.MODIF ';
    EdTrait.Text := '';
    EdTrait.SetFocus;
  end
  else if ModeTT = AjoutLg then    // ajout d'une srie de donnes
         begin
           StbAff.SimpleText := '  Rentrer le N de Sries puis X et Y  '+
                                                    '(espacs par des blancs)';
           EdTrait.Text := ' '+IntToStr(NSeries + 1);   // 25.07.07
           EdTrait.SetFocus;
           BtTrait.Visible := true;
         end
  else if ModeTT = SuppLg then    // suppression d'une ligne de donnes
         begin
           StbAff.SimpleText := ' Slectionner une ligne de DONNEES  supprimer puis OK';
           EdTrait.Text := '';
           EdTrait.SetFocus;
         end;
end;

procedure TFRegAff.FormActivate(Sender: TObject);
begin
  TitFiche := Caption;
  FlbAff.Update;         // mise  jour de la liste des fich.
  case ModeTT of
   AjoutLg :  Caption := TitFiche + ' - AJOUTER';
   ModifLg :  Caption := TitFiche + ' - MODIFIER';
   SuppLg :   Caption := TitFiche + ' - SUPPRIMER';
   SupFich : begin
               Caption := TitFiche + ' - SUPPRIMER DES FICHIERS';
               BtImp.Visible := False;
               BtEnregModif.Visible := False;
             end;
   Affich : Begin
            Caption := TitFiche + ' - AFFICHAGE';
            BtEnregModif.Visible := False;
            end;
   ModTitre : Caption := TitFiche + ' - MODIFIER le TITRE';
  end;
end;

procedure TFRegAff.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  EdTrait.Text := '';
  BtTrait.Visible := false;
  LiBAff.Clear;
  Caption := TitFiche;
  StbAff.SimpleText := '';
end;

procedure TFRegAff.FormCreate(Sender: TObject); // creation des listes de chaines
begin
  StlAffich := TStringList.Create;
  StlDonModif := TStringList.Create;
end;

procedure TFRegAff.FormDestroy(Sender: TObject);  // suppression
begin
  StlAffich.Free;
  StlDonModif.Free;
end;

procedure TFRegAff.LiBAffClick(Sender: TObject);  // affich zone selectionne
begin                                             // dans zone Edit
  if ModeTT = Affich then Exit;
  EdTrait.Text := LiBAff.Items[LiBAff.ItemIndex];
  IxAff := StlAffich.IndexOf(EdTrait.Text);    // index de la ligne slectionne
  BtTrait.Visible := true;
end;

end.

