unit RegCreatMul;                                   {19/03/2011}
                // Regression multiple cration des donnes initiales
interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ExtCtrls, Math, RegCreatPol;

type
  TFRegCreatMul = class(TFRegCreatPol)
    BtOK: TButton;
    procedure BtOKClick(Sender: TObject);                    // prpar. calcul
    procedure BtNouvSeriesClick(Sender: TObject); override;  // utilis  l'activation
    procedure FormActivate(Sender: TObject); override;
    procedure BtEnregSerieClick(Sender: TObject); override; // enregistrement srie
    procedure BtExecCalculClick(Sender: TObject); override; // prpar. calcul
    procedure EdTitRegExit(Sender: TObject); override;     // en tte memo -> OK
    procedure BtSauveDonClick(Sender: TObject); override;  // sauvegarde donnes
  private
    { Dclarations prives }
    Lg, Lgv : string;
    NumV : integer;  // Regression  multiple numro de la variable
  public
    { Dclarations publiques }
    procedure SauveDonnees; override;
  end;

var
  FRegCreatMul: TFRegCreatMul;

implementation

uses RegresPoly, RegresMultip, RegMenu;

const
  ChTitreM =
  ' Donner un TITRE,le NOMBRE de SERIES et de VAR.INDEPENTANTES puis OK';

{$R *.dfm}

procedure TFRegCreatMul.BtEnregSerieClick(Sender: TObject); // enregistrement srie
begin
//  inherited;
with FCalculMultiple do
begin
  if NumS <= NbSeries then
    begin
      if NumV <= FCalculMultiple.NbVarI then
        begin
          ChX := EdY.Text;          // enregistrement des Xi
          StlDon.Add(ChX);
          Inc(NumV);
          EdX.Text := '   X'+IntToStr(NumV);
          if NumV = NbVar then Edx.Text := '     Y';
          EdY.SetFocus;
          LgV := LgV + StringOfChar(' ',10-Length(ChX))+ ChX;
        end
        else begin              // enregistrement de Y
          ChY := EdY.Text;
          StlDon.Add(ChY);
          Lg :=  Format('%3d',[NumS]) + LgV + StringOfChar(' ',10-Length(ChY))+ ChY;
          StlDonA.Add(Lg);
          MemCreat.Lines.Add(Lg);
          Inc(NumS);
          EdN.Text := IntToStr(NumS);
          EdX.Text := '  X1';
          LgV := '';
          NumV := 1;
          EdY.SetFocus;
        end;
    end;
    if NumS > NbSeries then
    begin
      PanSauvecr.Visible := true;
      EdNomFcr.SetFocus;
      StBCreat.SimpleText := '  ENREGISTRER les donnes puis EXECUTER';
      BtNouvSeries.Visible := True;
      BtCalcul.Visible := True;
      FlbListDon.Mask := '*.mud';
    end;
end;
end;

procedure TFRegCreatMul.BtExecCalculClick(Sender: TObject);  // prpar. calcul
begin
   FcalculMultiple.EdDegre.Text := IntToStr(FcalculMultiple.NbVarI);
   FcalculMultiple.EdNomFic.Text := FcalculMultiple.NficSauv;
   FcalculMultiple.StbFDon.SimpleText := '   ';
   FcalculMultiple.EdTitre.Text :=  TitreReg;
   FcalculMultiple.EdNbS.Text := IntToStr(FcalculMultiple.NbSeries);
   FcalculMultiple.MemDon.Lines := FcalculMultiple.StlDonA;
   FcalculMultiple.BExecPoly := False;
   FcalculMultiple.ShowModal;
end;

procedure TFRegCreatMul.BtNouvSeriesClick(Sender: TObject);
begin
//  inherited;
  FcalculMultiple.StlDon.Clear;  // initialisation pour de nouvelles donnes
  FcalculMultiple.StlDonA.Clear;
  EdTitReg.Text := '';
  EdNbseries.Text := '';
  MemCreat.Clear;
  FcalculMultiple.NumS := 1;
  StBCreat.SimpleText := ChTitreM;
  EdTitReg.SetFocus;
  FcalculMultiple.ExtAff := '.mua';
end;

procedure TFRegCreatMul.BtOKClick(Sender: TObject); // nouvelle srie prpa
begin
//  inherited;
with FcalculMultiple do
  begin
    NbSeries := StrToInt(EdNbSeries.Text);
    FcalculMultiple.NbVarI := StrToInt(EdDeg.Text);  // = nbre var indpendantes
    NbVar := FcalculMultiple.NbVarI + 1;
    if NbSeries <= NbVar then        // vrification du nbre de sries
    begin
      MessageDlg('Le nbre de SERIES est INSUFFISANT', mtError, [mbOK], 0);
      EdNbSeries.SetFocus;
      Exit;
    end;
    NumS := 1;
    EdN.Text := IntToStr(NumS);
    DegreL := NbSeries - 1;       // degr de libert
    StlDon.Clear;
    StBCreat.SimpleText :=
      '  Rentrer Xi puis "Enregistrer ou Corriger" n fois, puis Enregistrer Y';
    Edx.Text := '   X1';
    NumV := 1;
    LgV := '';
    EdY.SetFocus;
    BtOK.Visible := False;
 end;
 TitreReg := UpperCase(EdTitReg.Text);
end;

procedure TFRegCreatMul.BtSauveDonClick(Sender: TObject);  // sauvegarde donnes
var
  Ext : string;
begin
  with FcalculMultiple do
  begin
    NFicSauv := Trim(EdNomFcr.Text);
    Ext := '.mud';
    if not FileExists(NficSauv+Ext) then SauveDonnees
    else begin
      if MessageDlg('Le fichier '+NFicSauv+Ext+' existe dj.'+CrLg+
         'Voulez vous l''ECRASER ? (O/N)', mtInformation,[mbYes,mbNo],0)= mrNo then
         begin
           EdNomFcr.SetFocus;
           Exit;
         end
         else
           begin
             SauveDonnees;
           end;
    end;
  end;
  BtExecCalcul.Visible := True;
  BtExecCalcul.SetFocus;
end;

procedure TFRegCreatMul.EdTitRegExit(Sender: TObject);
begin
//  inherited;
  TitreReg := UpperCase(EdTitReg.Text);
  EdTitReg.Text := TitreReg;
  MemCreat.Lines.Add(TitreReg);
  MemCreat.Lines.Add(Ch2AffDonM);
  MemCreat.Lines.Add('   ');
  BtOK.Visible := True;
end;

procedure TFRegCreatMul.FormActivate(Sender: TObject);
begin
//  inherited;
  StBCreat.SimpleText := ChTitreM;
  BtNouvSeries.Visible := False;
  BtNouvSeriesClick(Self)
end;

procedure TFRegCreatMul.SauveDonnees;  // sauvegarde donnes dans fichier
var Exts : string;
begin
with FcalculMultiple do
  begin
    StlDon.Add(IntToStr(NbSeries));
    StlDon.Add(IntToStr(NbVar));
    if Trim(TitreReg) = '' then TitreReg := EdTitre.Text;
    StlDon.Add(TitreReg);
    Exts := '.mud';
    StlDon.SaveToFile(NFicSauv+Exts);    // sauvegarde donnes brutes pour calcul

    StlDonA.Insert(0, '       '+UpperCase(TitreReg));
    StlDonA.Insert(1, '       ');
    StlDonA.Insert(2, '        REGRESSION   MULTIPLE ');
    StlDonA.Insert(3, '    ');
    StlDonA.Insert(4, '                DONNEES ');
    StlDonA.Insert(5,Ch2AffDonM);
    Exts := '.mua';
    StlDonA.SaveToFile(NFicSauv+ExtAff); // sauvegarde affichage donnes dans fichier
    StlDonA.Add('   ');
  end;
end;

end.
