unit RegCreatPol;                                  {17/07/2011}
               // rgression polynomiale cration des donnes initiales
interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls, Math  ;

type
  TFRegCreatPol = class(TForm)
    LaEquation: TLabel;
    LaTitDon: TLabel;
    Label7: TLabel;
    LaDegre: TLabel;
    LaTitre: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    EdN: TEdit;
    EdX: TEdit;
    EdY: TEdit;
    BtEnregSerie: TButton;
    EdNbSeries: TEdit;
    BtCorriger: TButton;
    EdDeg: TEdit;
    EdTitReg: TEdit;
    BtNouvSeries: TButton;
    PanSauvecr: TPanel;
    Label11: TLabel;
    Label3: TLabel;
    EdNomFcr: TEdit;
    BtSauveDon: TButton;
    StbCreat: TStatusBar;
    MemCreat: TMemo;
    BtExecCalcul: TButton;
    procedure BtNouvSeriesClick(Sender: TObject); virtual; //utilis  l'activation
    procedure FormActivate(Sender: TObject); virtual;
    procedure BtEnregSerieClick(Sender: TObject); virtual; // enregistrement srie
    procedure EdNbSeriesExit(Sender: TObject); 
    procedure BtCorrigerExit(Sender: TObject);
    procedure BtSauveDonClick(Sender: TObject); virtual;  // sauvegarde donnes
    procedure BtExecCalculClick(Sender: TObject); virtual;  // init pour calcul
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure EdTitRegExit(Sender: TObject); virtual;           // en tte memo
    procedure EdXKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure EdYKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure EdNomFcrKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
  private
    { Dclarations prives }
  public
    TitreReg : string;       // titre de la regression
    ChTitInit : string;      // titre initial de la fiche
    ChX, ChY : string;       // lecture des valeurs X et Y
    procedure SauveDonnees; virtual;
  end;

var
  FRegCreatPol: TFRegCreatPol;

implementation

uses RegresPoly, RegresMultip, RegMenu, RegAffich;

{$R *.dfm}

const
  ChTitre =
  ' Donner un TITRE puis le NOMBRE de SERIES et rentrer les DONNEES'+
                                                   ' X puis Y et ENREGISTRER' ;
  ChEquatPol = 'Y = B0 + B1 x X1 + B2 x X^2 + ... +  Bn-1 x X^n-1';
  ChDonPol =
    ' Entrer les DONNEES  :          X                                       Y';
  ChLabDegreP = ' Degr max. du polynome ';

procedure TFRegCreatPol.BtCorrigerExit(Sender: TObject);
begin
  EdX.SetFocus;
  FCalculPoly.StBFDon.SimpleText := ' CORRIGER la/les VALEUR(S) et continuer';
end;

procedure TFRegCreatPol.BtEnregSerieClick(Sender: TObject);
var I : integer;    // lecture des valeurs de X et Y, calcul de puissances de Y
  Lg : string;      // et enregistrement dans StlDon

begin
  with FCalculPoly do
  begin
    Chx := EdX.Text;
    Xtab[1] := StrToFloat(Chx);   // valeur de X
    StlDon.Add(Chx);           // sauvegarde des donnes X
    for I := 2 to (NbVar-1) do
    begin
       Xtab[I] := Xtab[I-1] * Xtab[1];        // calcul des puissances de X
       StlDon.Add(FloatToStr(Xtab[I])); // sauvegarde
    end;
    ChY := EdY.Text;
    Xtab[NbVar] := StrToFloat(ChY);  // lecture de Y et sauvegarde
    StlDon.Add(ChY);
    Lg := Format('%3d',[NumS]) +
          StringOfChar(' ',18-Length(FloatToStr(Xtab[1])))+ FloatToStr(Xtab[1])+
          StringOfChar(' ',18-Length(FloatToStr(Xtab[NbVar])))+ FloatToStr(Xtab[NbVar]);
    MemCreat.Lines.Add(Lg);
    StlDonA.Add(Lg);
    Inc(NumS);
    if NumS <= NbSeries then begin
                            EdX.SetFocus;
                            EdN.Text := IntToStr(NumS);
                          end
                    else
                    begin
                      PanSauvecr.Visible := true;
                      EdNomFcr.SetFocus;
                      BtNouvSeries.Visible := True;
                      StbCreat.SimpleText :=
              '  ENREGISTRER les donnes puis EXECUTER ou sortir pour corriger';
                    end;
    NAffLg := NumS;
  end;
end;

procedure TFRegCreatPol.BtExecCalculClick(Sender: TObject);
begin
  StBCreat.SimpleText := '   ';
  FCalculPoly.EdTitre.Text :=  TitreReg; // initial. de la fiche FCalculPoly calcul regression
  FCalculPoly.EdNbs.Text := IntToStr(FCalculPoly.NbSeries);
  FCalculPoly.EdDegre.Text := IntToStr(FCalculPoly.NbVar-2);
  FCalculPoly.EdNomFic.text := FCalculPoly.NficSauv;
  FCalculPoly.MemDon.Lines := FCalculPoly.StlDonA;
  FCalculPoly.BExecPoly := False;
  FCalculPoly.F1 := F1init;
  FCalculPoly.F2 := F2init;
  FCalculPoly.ShowModal;
end;

procedure TFRegCreatPol.SauveDonnees;
var Exts : string;
begin
with FCalculPoly do
  begin
    StlDon.Add(IntToStr(NbSeries));
    StlDon.Add(IntToStr(NbVar));
    if Trim(TitreReg) = '' then TitreReg := EdTitre.Text;
    StlDon.Add(TitreReg);
    Exts := '.pyd';
    StlDon.SaveToFile(NFicSauv+Exts);    // sauvegarde donnes brutes pour calcul

    StlDonA.Insert(0, '       '+UpperCase(TitreReg));
    StlDonA.Insert(1, '    ');
    StlDonA.Insert(2, '        REGRESSION   POLYNOMIALE  ');
    StlDonA.Insert(3, '   ');
    StlDonA.Insert(4, '                DONNEES ');
    StlDonA.Insert(5,Ch2AffDonP);
    Exts := '.pya';                    // dfini l'extension des fich. affichage
    StlDonA.SaveToFile(NFicSauv+Exts); // sauvegarde affichage donnes dans fichier
    StlDonA.Add('   ');
  end;
end;

procedure TFRegCreatPol.BtSauveDonClick(Sender: TObject);
var
  Ext : string;
begin
  with FCalculPoly do
  begin
    NFicSauv := Trim(EdNomFcr.Text);
    Ext := '.pyd';
    if FileExists(NficSauv+Ext) then
      if MessageDlg('Le fichier '+NFicSauv+Ext+' existe dj.'+CrLg+
         'Voulez vous l''ECRASER ? (O/N)', mtInformation,[mbYes,mbNo],0)= mrNo then
         begin
           EdNomFcr.SetFocus;
           Exit;
         end
         else
           begin
             SauveDonnees;
           end
      else SauveDonnees;
  end;
  BtExecCalcul.Visible := True;
  BtExecCalcul.SetFocus;
end;

procedure TFRegCreatPol.BtNouvSeriesClick(Sender: TObject);
begin
  FcalculPoly.StlDon.Clear;  // initialisation des Stringlist pour de nouvelles donnes
  FcalculPoly.StlDonA.Clear;
  EdTitReg.Text := '';
  EdNbseries.Text := '';
  MemCreat.Clear;
  ChTitInit := Caption;
  LaEquation.Caption := ChEquatPol;
  LaTitDon.Caption := ChDonPol;
  LaDegre.Caption := ChLabDegreP;
  Caption := ChTitInit + '     REGRESSION POLYNOMIALE';
  FcalculPoly.NumS := 1;
  StBCreat.SimpleText := ChTitre;
  EdTitReg.SetFocus;
  FcalculPoly.ExtAff := '.pya';
end;

procedure TFRegCreatPol.EdNbSeriesExit(Sender: TObject);
begin
with FcalculPoly do
  begin
    NbSeries := StrToInt(EdNbSeries.Text);
    NbVar := NbMaxVar;                // n var. indpendantes + une var. dpendante Y
    EdDeg.Text := IntToStr(NbVar-2);    // degmax possible
    EdX.SetFocus;
    NumS := 1;
    EdN.Text := IntToStr(NumS);
    DegreL := NbSeries - 1;
    StlDon.Clear;
    StBCreat.SimpleText := ' Rentrer X puis Y et "Enregistrer ou Corriger",  n fois'
  end;
end;
procedure TFRegCreatPol.EdNomFcrKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = Vk_Return then BtSauveDon.SetFocus;
end;

procedure TFRegCreatPol.EdTitRegExit(Sender: TObject); // en tte memo
begin
  TitreReg := UpperCase(EdTitReg.Text);
  EdTitReg.Text := TitreReg;
  MemCreat.Lines.Add(TitreReg);
  MemCreat.Lines.Add(Ch2AffDonP);
  MemCreat.Lines.Add('   ')
end;

procedure TFRegCreatPol.EdXKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = Vk_Return then EdY.SetFocus;
end;

procedure TFRegCreatPol.EdYKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = Vk_Return then BtEnregSerie.SetFocus;
end;

procedure TFRegCreatPol.FormActivate(Sender: TObject);
begin
  StBCreat.SimpleText := ChTitre;
  BtNouvSeries.Visible := False;
  BtNouvSeriesClick(self)
end;

procedure TFRegCreatPol.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Caption := ChTitInit;
  FcalculPoly.NficSauv := 'WEssai';
  BtExecCalcul.Visible := False;
  EdDeg.Text := '';
  EdN.Text := '1';
  EdX.Text := '';
  EdY.Text := '';
end;

end.

