unit RegMenu;                                       {05/03/2012}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus;

type
  TFRegMenu = class(TForm)
    MmRegmenu: TMainMenu;
    Quitter: TMenuItem;
    GestionDonnees: TMenuItem;
    Affichage: TMenuItem;
    SupFichier: TMenuItem;
    ModifTitre: TMenuItem;
    RegressionPoly: TMenuItem;
    CreationSeriePOL: TMenuItem;
    ExecutionCalculPOL: TMenuItem;
    RegressionMULTIPLE: TMenuItem;
    CreationSeriesMUL: TMenuItem;
    ExecCalculMul: TMenuItem;
    AffichageResulPOL: TMenuItem;
    AffichResultMUL: TMenuItem;
    ModificationlignePOL: TMenuItem;
    AjoutlignePOL: TMenuItem;
    SuppressionLignePOL: TMenuItem;
    ModificationligneMUL: TMenuItem;
    AjoutLigneMUL: TMenuItem;
    SuppressionLigneMUL: TMenuItem;
    GrapheFonctionPoly: TMenuItem;
    procedure QuitterClick(Sender: TObject);
    procedure AffichageClick(Sender: TObject);
    procedure SupFichierClick(Sender: TObject);
    procedure ModifTitreClick(Sender: TObject);
    procedure CreationSeriePOLClick(Sender: TObject);  // cration donnes poly
    procedure ExecutionCalculPOLClick(Sender: TObject);
    procedure ExecCalculMulClick(Sender: TObject);
    procedure CreationSeriesMULClick(Sender: TObject);
    procedure AffichageResulPOLClick(Sender: TObject);
    procedure AffichResultMULClick(Sender: TObject);
    procedure AjoutlignePOLClick(Sender: TObject);
    procedure ModificationlignePOLClick(Sender: TObject);
    procedure SuppressionLignePOLClick(Sender: TObject);
    procedure ModificationligneMULClick(Sender: TObject);
    procedure AjoutLigneMULClick(Sender: TObject);
    procedure SuppressionLigneMULClick(Sender: TObject);
    procedure GraphedelaFonctionPolyClick(Sender: TObject);
    procedure RegressionPolyClick(Sender: TObject);
    procedure RegressionMULTIPLEClick(Sender: TObject); // reg. multiple
  private
    { Dclarations prives }
    procedure P_Affichage;       //initiation
    procedure P_AjoutLg;
    procedure P_ModificationLg;
    procedure P_SuppressionLg;
  public
    { Dclarations publiques }
  end;

var
  FRegMenu: TFRegMenu;

implementation

uses RegresPoly, RegAffich, RegresMultip, RegCreatMul, RegCreatPol, RegGraphePoly,
     CourbAff;

{$R *.dfm}
procedure TFRegMenu.P_Affichage;
begin
  FRegAff.ModeTT := Affich;
  FRegAff.EdTrait.Visible := false;
  FRegAff.BtTrait.Visible := false;
  FRegAff.StbAff.SimpleText := '';
  FRegAff.MemAff.Visible := true;
  FregAff.BtTrait.Visible := False;
  FRegAff.BtImp.Visible := True;
end;

procedure TFRegMenu.P_AjoutLg;
begin
  FRegAff.ModeTT := AjoutLg;
  FRegAff.EdTrait.Visible := true;
  FRegAff.BtTrait.Visible := false;
  FRegAff.MemAff.Visible := false;
end;

procedure TFRegMenu.P_ModificationLg;
begin
  FRegAff.ModeTT := ModifLg;
  FRegAff.EdTrait.Visible := true;
  FRegAff.BtTrait.Visible := false;
  FRegAff.MemAff.Visible := false;
end;

procedure TFRegMenu.AffichageClick(Sender: TObject);
begin
  P_Affichage;    // initialisation affichage
  FRegAff.FlbAff.Mask := '*.pya;*.pyd;*.pyr;*.coef;*.mua;*.mud;*.mur';
  FRegAff.ShowModal;
  FRegAff.BtImp.Visible := False;
  FregAff.BtTrait.Visible := True;
end;

procedure TFRegMenu.AffichageResulPOLClick(Sender: TObject);
begin
  P_Affichage;
  FRegAff.FlbAff.Mask := '*.pya;*.pyd;*.pyr;*.coef';
  FRegAff.ShowModal;
  FRegAff.BtImp.Visible := False;
  FregAff.BtTrait.Visible := True;
end;


procedure TFRegMenu.AffichResultMULClick(Sender: TObject);
begin
  P_Affichage;
  FRegAff.FlbAff.Mask := '*.mua;*.mud;*.mur';
  FRegAff.ShowModal;
  FRegAff.BtImp.Visible := False;
  FregAff.BtTrait.Visible := True;
end;

procedure TFRegMenu.AjoutLigneMULClick(Sender: TObject);
begin
  P_AjoutLg;   // initialisation
  FRegAff.FlbAff.Mask := '*.mua';
  FRegAff.ShowModal;
end;

procedure TFRegMenu.AjoutlignePOLClick(Sender: TObject);
begin
  P_AjoutLg;
  FRegAff.FlbAff.Mask := '*.pya';
  FRegAff.ShowModal;
end;

procedure TFRegMenu.CreationSeriePOLClick(Sender: TObject);
begin
  FCalculPoly.BRegMultiple := False;
  if FregCreatPol = nil then FRegCreatPol := TFRegCreatPol.Create(Self);
try
  FRegCReatPol.ShowModal;
finally
  FRegCreatPol.Free;
end;
end;

procedure TFRegMenu.CreationSeriesMULClick(Sender: TObject);
begin
  FcalculPoly.BRegMultiple := True;
  if FRegCreatMul = nil then FRegCreatMul := TFRegCreatMul.Create(Self);
try
  FRegCreatMul.ShowModal;
finally
  FRegCreatMul.Free;
end;
end;

procedure TFRegMenu.ExecCalculMulClick(Sender: TObject);
begin
  FcalculPoly.BRegMultiple := True;
    try
      FCalculMultiple.BExecPoly := True;   //exec  partir de RegMultiple
      FcalculMultiple.ShowModal;
    finally
      FCalculMultiple.Free;
    end;
end;

procedure TFRegMenu.ExecutionCalculPOLClick(Sender: TObject);
begin
  FcalculPoly.BRegMultiple := False;
  FcalculPoly.F1 := F1init;
  FcalculPoly.F2 := F2init;
  FcalculPoly.BExecPoly := True; // exec  partir de RegPoly
  FcalculPoly.ShowModal;
end;

procedure TFRegMenu.GraphedelaFonctionPolyClick(Sender: TObject);
begin
FGraphPoly := TFGraphPoly.Create(Self);
  try
    FGraphPoly.ShowModal;
  finally
    FGraphPoly.Free;
    FAffGraph.Free;
  end;
end;

procedure TFRegMenu.ModificationligneMULClick(Sender: TObject);
begin
  P_ModificationLg;   // initialisation
  FRegAff.FlbAff.Mask := '*.mua';
  FRegAff.ShowModal
end;

procedure TFRegMenu.ModificationlignePOLClick(Sender: TObject);
begin
  P_ModificationLg;
  FRegAff.FlbAff.Mask := '*.pya';
  FRegAff.ShowModal
end;

procedure TFRegMenu.ModifTitreClick(Sender: TObject);
begin
  FRegAff.ModeTT := ModTitre;
  FRegAff.EdTrait.Visible := true;
  FRegAff.BtTrait.Visible := false;
  FRegAff.FlbAff.Mask := '*.pya;*.mua';
  FRegAff.MemAff.Visible := false;
  FRegAff.ShowModal;
end;

procedure TFRegMenu.QuitterClick(Sender: TObject);
begin
  Application.Terminate;
end;

procedure TFRegMenu.RegressionMULTIPLEClick(Sender: TObject);
begin
  if FCalculMultiple = nil then FCalculMultiple := TFCalculMultiple.Create(Self);
end;

procedure TFRegMenu.RegressionPolyClick(Sender: TObject);
begin
  if FAffGraph = nil then FAffGraph := TFAffGraph.Create(Self);
end;

procedure TFRegMenu.SupFichierClick(Sender: TObject);
begin
  FregAff.ModeTT := SupFich;
  FRegAff.EdTrait.Visible := true;
  FRegAff.BtTrait.Visible := false;
  FRegAff.FlbAff.Mask := '*.pyr;*.mur;*.pya;*.mua';
  FRegAff.StbAff.SimpleText :=
        ' Suppression du fichier Rsultats OU tous les fichiers';
  FRegAff.ShowModal
end;

procedure TFRegMenu.P_SuppressionLg;
begin
  FRegAff.ModeTT := SuppLg;
  FRegAff.EdTrait.Visible := True;
  FRegAff.BtTrait.Visible := false;
end;

procedure TFRegMenu.SuppressionLigneMULClick(Sender: TObject);
begin
  P_SuppressionLg;
  FRegAff.FlbAff.Mask := '*.mua';
  FRegAff.ShowModal;
end;

procedure TFRegMenu.SuppressionLignePOLClick(Sender: TObject);
begin
  P_SuppressionLg;
  FRegAff.FlbAff.Mask := '*.pya';
  FRegAff.ShowModal;
end;

end.


